<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_hotelRatePlanTax ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_hotelRatePlanTax extends AbstractStructArrayBase
{
    /**
     * The Tax
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_hotelRatePlanTax[]
     */
    public $Tax;
    /**
     * Constructor method for ArrayOfJPSOAP_hotelRatePlanTax
     * @uses ArrayOfJPSOAP_hotelRatePlanTax::setTax()
     * @param \StructType\JPSOAP_hotelRatePlanTax[] $tax
     */
    public function __construct(array $tax = array())
    {
        $this
            ->setTax($tax);
    }
    /**
     * Get Tax value
     * @return \StructType\JPSOAP_hotelRatePlanTax[]|null
     */
    public function getTax()
    {
        return $this->Tax;
    }
    /**
     * Set Tax value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanTax[] $tax
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanTax
     */
    public function setTax(array $tax = array())
    {
        foreach ($tax as $arrayOfJPSOAP_hotelRatePlanTaxTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_hotelRatePlanTaxTaxItem instanceof \StructType\JPSOAP_hotelRatePlanTax) {
                throw new \InvalidArgumentException(sprintf('The Tax property can only contain items of \StructType\JPSOAP_hotelRatePlanTax, "%s" given', is_object($arrayOfJPSOAP_hotelRatePlanTaxTaxItem) ? get_class($arrayOfJPSOAP_hotelRatePlanTaxTaxItem) : gettype($arrayOfJPSOAP_hotelRatePlanTaxTaxItem)), __LINE__);
            }
        }
        $this->Tax = $tax;
        return $this;
    }
    /**
     * Add item to Tax value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_hotelRatePlanTax $item
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanTax
     */
    public function addToTax(\StructType\JPSOAP_hotelRatePlanTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_hotelRatePlanTax) {
            throw new \InvalidArgumentException(sprintf('The Tax property can only contain items of \StructType\JPSOAP_hotelRatePlanTax, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Tax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_hotelRatePlanTax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Tax
     */
    public function getAttributeName()
    {
        return 'Tax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_hotelRatePlanTax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
